<?
/*
*   +----------------------------------+
*    Nom du Filtre :  zoom_text                      
*   +----------------------------------+
*    Date : dimanche 5 dcembre 2004
*    Auteur :  James <klike@free.fr>, Pepito <cypress@worldonline.fr>
*   +-------------------------------------+
*    Fonctions de ce filtre :
*     Proposer un lien pour effectuer un zoom sur vos textes
*   +-------------------------------------+ 
*  
*   exemple d'utilisation dans un squelette :
*   ici, nous proposons 3 niveau de zoom avec des liens texte
*   [(#TEXTE|zoom_text{3,texte})]
*   ici, nous proposons 1 niveau de zoom avec des liens image
*   [(#TEXTE|zoom_text{1,image})]
*
* Pour toute suggestion, remarque, proposition d'ajout
* reportez-vous au forum de l'article :
* http://www.spip-contrib.net/article342.html
*/

function zoom_text($texte, $level = 0, $type_lien = 'texte') {
        global $clean_link;
        global $zoom_lien_avant, $zoom_lien_apres;
	global $tailles;
        global $niveau;

        // On peut personnaliser la taille des polices
        // pour cela, dfinir les variables globales $tailles
        // dans ecrire/mes_options.php3
        tester_variable("tailles", array(1 => "100%", "120%", "160%"));

        if($level == 0)
                // si il n'y as pas de zoom sur l'article, on affiche pas les liens ou boutons de zoom.
                // et on renvoie le texte normal.
                return $texte;

        // On peut personnaliser la prsentation de l'affichage des liens ou boutons de Zoom.
        // pour cela, dfinir les variables globales $zoom_lien_avant
        // et $zoom_lien_apres dans ecrire/mes_options.php3
        tester_variable("zoom_lien_avant", "<div align='right'>\nZoom texte<br>");
        tester_variable("zoom_lien_apres", "</div>\n");

        // si la variable niveau n'est pas dfini dans l'URL,
        // on initialise la variable  1, afin d'afficher le premier style.
        $niveau = max(1, intval($niveau));
        $taille_caracteres = $tailles[$niveau];

        // Conserver les variables $url, $niveau et $i dans le lien hypertexte.
        // la variable $border permet d'indiquer  l'utilisateur sur quelle zoom il se trouve.
        $zoom_lien = $zoom_lien_avant;
        
        for($i=1 ; $i<=$level ; $i++) {
                $clean_link->addVar('niveau', $i);
                $url = $clean_link->getUrl();
                switch($type_lien) {
                        case 'image':
                        $border = ($niveau == $i)?1:0;
                        $zoom_lien .= "<a href='".$url."'><img src='IMG/zoom$i.gif' border='".$border."'></a> ";
                        break;
                        case 'texte':
                        default:
                        $zoom_lien .= "<a href='".$url."'>zoom$i</a> ";
                        break;
                }
        }

        $zoom_lien .= $zoom_lien_apres;

        //modification du texte :
        $texte = preg_replace("/(class=\"spip\")/i", "\\1 style=\"font-size: ".$taille_caracteres.";\"", $texte, -1);

        return $zoom_lien.$texte;
}
?>